-- categories
CREATE TABLE "categories" (
	"cat_id"		serial primary key,
	"name"			text NOT NULL
);

-- bookmarks
CREATE TABLE "bookmarks" (
	"mark_id"		serial primary key,
	"url"			text NOT NULL,
	"title"			text NOT NULL,
	"comment"		text,
	"created"		timestamp
);

-- cat_links
CREATE TABLE "cat_links" (
	"cat_id"		integer NOT NULL REFERENCES categories (cat_id),
	"parent"		integer NOT NULL REFERENCES categories (cat_id)
);

-- bm_links
CREATE TABLE "bm_links" (
	"mark_id"		integer NOT NULL REFERENCES bookmarks (mark_id),
	"parent"		integer NOT NULL REFERENCES categories (cat_id)
);

-- users
CREATE TABLE "users" (
	"user_id"		serial primary key,
	"username"		text NOT NULL,
	"password"		text NOT NULL
);


-- Create root category
INSERT INTO categories (cat_id,name) VALUES ('0','Bookmarks');

-- Create default admin user
INSERT INTO users (username,password) VALUES ('admin','adminpass');
