<?php
	/* Get the PEAR stuff */
	require_once('DB.php');

	/* Include our stuff */
	include(".defs");
	include("${rootdir}/php/main.php");

	/* Start up */
	$db = db_connect();

	/* Auth */
	if($admin_auth_req==1)
	{ admin_auth(); }
?>
<?php print("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n")?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- $Fuller: myprograms/htbm/web/bmadmin.php,v 1.15 2002/10/06 12:17:55 fullermd Exp $ -->
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>
Bookmark administration
</title>
<style type="text/css" media="all">
@import "bmark.css";
</style>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
</head>
<body>
<?php
	/* Figure out what mode we're in */
	if($commit)
	{
		/*
		 * We're in commit mode; enter the changes requested, print a
		 * success/error message, and slap up a link to wherever is
		 * appropriate.
		 */
		if($new==1 || $edit==1)
		{
			/* New and edit are ALMOST the same.  Share code. */
			/* Do some sanity checking */
			if(!$url)
			{
				print("<p>ERROR: Need URL specified!</p>\n");
				print("<p><a href=\"$self?new=1\">Enter new</a></p>\n");
				exit;
			}
			if(!$title)
			{
				print("<p>No title entered, using URL.");
				print("You may want to edit this bookmark and add a real title.");
				print("</p>\n");
				$title = $url;
			}
			$urlp = parse_url($url);
			if(strlen($urlp['scheme']) < 1)
			{
				print("<p>No URL scheme specified, assuming http://.");
				print("You should edit this bookmark if this isn't right.</p>\n");
				$url = "http://" . $url;
			}

			/* Escape info for safety */
			$cat_id = $db->quote($cat_id);
			$url = $db->quote($url);
			$title = $db->quote($title);
			$comment = $db->quote($comment);

			/* Start this transaction */
			$querystr = "BEGIN";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Stuff the data */
			if($new==1)
			{
				$mymarkid = "nextval('bookmarks_mark_id_seq')";
				$querystr = "INSERT INTO bookmarks "
						. "(mark_id,url,title,comment,created) "
						. "VALUES ($mymarkid,$url,$title,$comment,"
						. "CURRENT_TIMESTAMP)";
				$mymarkid = "currval('bookmarks_mark_id_seq')";
			}
			else if($edit==1)
			{
				$mymarkid = $db->quote($mark_id);
				$querystr = "UPDATE bookmarks SET "
						. "url=$url, title=$title, "
						. "comment=$comment "
						. "WHERE mark_id=$mymarkid";
			}
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* And the parenting */
			foreach($parent as $key => $thisparent)
			{
				$thisold = $old_parent[$key];
				d_print("<!-- thisparent is '$thisparent',");
				d_print("thisold is '$thisold' -->\n");
				if( ($thisparent == -1) && ($thisparent != $thisold) )
				{
					$querystr = "DELETE FROM bm_links "
							. "WHERE parent='$thisold' "
							. "AND mark_id='$mark_id'";
					d_print("<!-- query is '$querystr' -->\n");
					$result = $db->query($querystr);
					if(DB::isError($result))
					{ die($result->getMessage()); }
				}
				else if( ($thisparent != $thisold) || ($new==1) )
				{
					if( ($thisold==-1) || ($new==1) )
					{
						$querystr = "INSERT INTO bm_links "
								. "(mark_id,parent) "
								. "VALUES ($mymarkid,$thisparent)";
					}
					else
					{
						$querystr = "UPDATE bm_links SET "
								. "parent='$thisparent' "
								. "WHERE parent='$thisold' "
								. "AND mark_id=$mymarkid";
					}

					d_print("<!-- query is '$querystr' -->\n");
					$result = $db->query($querystr);
					if(DB::isError($result))
					{ die($result->getMessage()); }
				}
			}

			/* End this transaction */
			$querystr = "COMMIT";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* If we get here, success! */
			if($new==1)
			{ print("<p>New bookmark added!</p>\n"); }
			else if($edit==1)
			{ print("<p>Bookmark $mark_id changed!</p>\n"); }
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else if($dele==1)
		{
			/* Start this transaction */
			$querystr = "BEGIN";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Delete the links */
			$querystr = "DELETE FROM bm_links WHERE mark_id='$mark_id'";
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Delete the entry */
			$querystr = "DELETE FROM bookmarks WHERE mark_id='$mark_id'";
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* End this transaction */
			$querystr = "COMMIT";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Success */
			print("<p>Ex-bookmark number $mark_id deleted!</p>\n");
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else if($catnew==1 || $catedit==1)
		{
			/* Again, new and edit are nearly identical */

			/* Escape for safety */
			$name = $db->quote($name);

			/* Start this transaction */
			$querystr = "BEGIN";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Write edited category information */
			if($catnew==1)
			{
				$mycid = "nextval('categories_cat_id_seq')";
				$querystr = "INSERT INTO categories "
						. "(cat_id,name) "
						. "VALUES ($mycid,$name)";
				$mycid = "currval('categories_cat_id_seq')";
			} else {
				$mycid = $db->quote($cat_id);
				$querystr = "UPDATE categories SET "
						. "name=$name "
						. "WHERE cat_id='$cat_id'";
			}
			d_print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Update parents */
			foreach($parent as $key => $thisparent)
			{
				$thisold = $old_parent[$key];
				d_print("<!-- thisparent is '$thisparent',");
				d_print("thisold is '$thisold' -->\n");
				if( ($thisparent == -1) && ($thisparent != $thisold) )
				{
					$querystr = "DELETE FROM cat_links "
							. "WHERE parent='$thisold' "
							. "AND cat_id='$cat_id'";
					d_print("<!-- query is '$querystr' -->\n");
					$result = $db->query($querystr);
					if(DB::isError($result))
					{ die($result->getMessage()); }
				}
				else if( ($thisparent != $thisold) || ($catnew==1) )
				{
					if( ($thisold==-1) || ($catnew==1) )
					{
						$querystr = "INSERT INTO cat_links "
								. "(cat_id,parent) "
								. "VALUES ($mycid,$thisparent)";
					}
					else
					{
						$querystr = "UPDATE cat_links SET "
								. "parent='$thisparent' "
								. "WHERE parent='$thisold' "
								. "AND cat_id=$mycid";
					}

					d_print("<!-- query is '$querystr' -->\n");
					$result = $db->query($querystr);
					if(DB::isError($result))
					{ die($result->getMessage()); }
				}
			}

			/* Commit this transaction */
			$querystr = "COMMIT";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Success */
			if($catnew==1)
			{ print("<p>New category added!</p>\n"); }
			else
			{ print("<p>Category info updated for category $cat_id.</p>\n"); }
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else if($catdele==1)
		{
			/*
			 * First, see if we CAN delete it.  If it has children, we'll
			 * just bail right now.  We need to add more flexibility
			 * here.
			 */
			$querystr = "SELECT COUNT(mark_id) FROM bm_links "
					. "WHERE parent='$cat_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$temp = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$nbm = $temp[0];

			$querystr = "SELECT COUNT(cat_id) FROM cat_links "
					. "WHERE parent='$cat_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$temp = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$nsc = $temp[0];

			/* See what we have, error out if necessary */
			if($nbm>0 || $nsc>0)
			{
				print("<h1>Error</h1>\n");
				print("<p>Category $cat_id has children ");
				print("($nsc categories, $nbm bookmarks) ");
				print("and thus can't be deleted.</p>\n");
				print("<p>\n");
				print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
				print("</p>\n");
				exit;
			}

			/* Begin this transaction */
			$querystr = "BEGIN";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Delete an entry */
			$querystr = "DELETE FROM cat_links WHERE cat_id='$cat_id'";
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			$querystr = "DELETE FROM categories WHERE cat_id='$cat_id'";
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Commit this transaction */
			$querystr = "COMMIT";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Success */
			print("<p>Ex-category number $cat_id deleted!</p>\n");
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else
		{
			/* XXX WRITEME XXX */
			exit;
		}
	}
	else
	{
		/* Regular modes */
		if($new==1)
		{
			/* New bookmark to create */
			?>
<h1 class="center">
Add new bookmark
</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			/* Create a form to enter a new bookmark */
			$bminfo = array();
			$bminfo['parents'] = array('0');
			print_bmark_form($bminfo);
			?>
<div>
<input type="hidden" name="new" value="1" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($edit==1)
		{
			/* Edit existing bookmark */
			$querystr = "SELECT bookmarks.mark_id,url,title,comment,"
					. "bm_links.parent "
					. "FROM bookmarks "
					. "FULL OUTER JOIN bm_links USING (mark_id) "
					. "WHERE mark_id='$mark_id'";
			d_print("<!-- Query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Bookmark ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			/* Build up the info */
			$bminfo = array();
			$bminfo['parents'] = array();
			while( $info = $result->fetchRow(DB_FETCHMODE_ASSOC) )
			{
				$bminfo['mark_id'] = $info['mark_id'];
				$bminfo['url'] = $info['url'];
				$bminfo['title'] = stripslashes($info['title']);
				$bminfo['comment'] = stripslashes($info['comment']);
				array_unshift($bminfo['parents'], $info['parent']);
			}
			print("<form action=\"$self\" method=\"post\">\n");
			print_bmark_form($bminfo);
		?>
<div>
<input type="hidden" name="edit" value="1" />
<input type="hidden" name="mark_id" value="<?php echo("$mark_id")?>" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($dele==1)
		{
			/* Delete existing bookmark */
			$querystr = "SELECT bookmarks.mark_id,url,title,comment,"
					. "bm_links.parent "
					. "FROM bookmarks "
					. "FULL OUTER JOIN bm_links USING (mark_id) "
					. "WHERE mark_id='$mark_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Bookmark ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			$bminfo = array();
			$bminfo['parents'] = array();
			while( $info = $result->fetchRow(DB_FETCHMODE_ASSOC) )
			{
				$bminfo['mark_id'] = $info['mark_id'];
				$bminfo['url'] = $info['url'];
				$bminfo['title'] = $info['title'];
				$bminfo['comment'] = $info['comment'];
				array_unshift($bminfo['parents'], $info['parent']);
			}
		?>
<h1>CONFIRM DELETE</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			print_bmark_form($bminfo);
			?>
<div>
<input type="hidden" name="dele" value="1" />
<input type="hidden" name="mark_id" value="<?php echo("$mark_id")?>" />
</div>
<p>
Are you <em>SURE</em> you want to permamently delete this bookmark?
</p>
<p>
<input type="submit" name="commit" value="Commit" />
</p>
</form>
<?php
		}
		else if($catedit==1)
		{
			/* Edit existing category */
			/*
			 * XXX I'm not sure the FULL OUTER JOIN method is precisely
			 * correct; though it seems to give correct results in all
			 * test cases so far, I can't prove it.  So, this is an
			 * ugly-ass query that accomplishes the goal in a provably
			 * correct (though ugly) way.
			 */
			/*
			$querystr = "SELECT categories.cat_id,categories.name,"
					. "cat_links.parent "
					. "FROM categories,cat_links "
					. "WHERE categories.cat_id=cat_links.cat_id "
					. "AND categories.cat_id='$cat_id'";
			*/
			$querystr = "SELECT categories.cat_id,name,parent "
					. "FROM categories "
					. "FULL OUTER JOIN cat_links USING (cat_id) "
					. "WHERE cat_id='$cat_id'";
			d_print("<!-- Query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Category ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			/*
			 * We have to parse this out into a nice format to send into
			 * print_cat_form();
			 */
			$catinfo = array();
			$catinfo['parents'] = array();
			while( $info = $result->fetchRow(DB_FETCHMODE_ASSOC) )
			{
				$catinfo['cat_id'] = $info['cat_id'];
				$catinfo['name'] = stripslashes($info['name']);
				array_unshift($catinfo['parents'], $info['parent']);
			}

			print("<form action=\"$self\" method=\"post\">\n");
			print_cat_form($catinfo);
		?>
<div>
<input type="hidden" name="catedit" value="1" />
<input type="hidden" name="cat_id" value="<?php echo("$cat_id")?>" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($catnew==1)
		{
			/* New category to create */
			?>
<h1 class="center">
Add new category
</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			/* Create a form to enter a new bookmark */
			$catinfo = array();
			$catinfo['parents'] = array('0');
			print_cat_form($catinfo);
			?>
<div>
<input type="hidden" name="catnew" value="1" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($catdele==1)
		{
			/* Delete existing bookmark */
			$querystr = "SELECT categories.cat_id,name,parent "
					. "FROM categories "
					. "FULL OUTER JOIN cat_links USING (cat_id) "
					. "WHERE cat_id='$cat_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Category ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			/* Build catinfo */
			$catinfo = array();
			$catinfo['parents'] = array();
			while( $info = $result->fetchRow(DB_FETCHMODE_ASSOC) )
			{
				$catinfo['cat_id'] = $info['cat_id'];
				$catinfo['name'] = $info['name'];
				array_unshift($catinfo['parents'], $info['parent']);
			}
		?>
<h1>CONFIRM DELETE</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			print_cat_form($catinfo);
			?>
<div>
<input type="hidden" name="catdele" value="1" />
<input type="hidden" name="cat_id" value="<?php echo("$cat_id")?>" />
</div>
<p>
Are you <em>SURE</em> you want to permamently delete this category?
</p>
<p>
<input type="submit" name="commit" value="Commit" />
</p>
</form>
<?php
		}

		/* Other stuff */
	}
		?>
<p class="center">
<a href="http://validator.w3.org/check/referer">
<img src="http://www.w3.org/Icons/valid-xhtml10"
  alt="Valid XHTML 1.0!" height="31" width="88" /></a>
<a href="http://jigsaw.w3.org/css-validator/check/referer">
<?php /* <img style="border:0;width:88px;height:31px" */ ?>
<img src="http://jigsaw.w3.org/css-validator/images/vcss"
  alt="Valid CSS!" height="31" width="88" /></a>
</p>
</body>
</html>
