<?php
/* $Fuller: myprograms/htbm/web/php/categories.php,v 1.11 2002/10/06 12:19:16 fullermd Exp $ */

/* Ugly-ass hack to deal with damnfool scoping between these functions */
$buildcat=array();
$childpath=array();

function build_categories()
{
	global $debug;
	global $db;
	global $buildcat;
	global $childpath;

	# If we're in 'normal' mode, over-protect ourselves.
	if($debug!=1)
	{ $buildcat = array(); }

	/* Grab all the info from the 'categories' */
	$querystr = "SELECT cat_id,name FROM categories ORDER BY name";
	$result = $db->query($querystr);
	if(DB::isError($result))
	{ die($result->getMessage()); }

	while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	{
		$cid = $row['cat_id'];
		$name = stripslashes($row['name']);

		d_print("<!-- Adding category $cid -->\n");

		/* Register our info */
		$buildcat[$cid]['cid'] = $cid;
		$buildcat[$cid]['name'] = $name;

		$buildcat[$cid]['has_children'] = 0;
		$buildcat[$cid]['children'] = array();
		$buildcat[$cid]['parents'] = array();
	}

	/* Suck down the parent links */
	$querystr = "SELECT cat_id,parent FROM cat_links ORDER BY cat_id";
	$result = $db->query($querystr);
	while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	{
		$cid = $row['cat_id'];
		$parent = $row['parent'];

		array_push($buildcat[$cid]['parents'], $parent);

		if($cid!=0)
		{
			d_print("<!-- Registering $cid as child of $parent -->\n");
			$buildcat[$parent]['has_children'] = 1;
			array_push($buildcat[$parent]['children'], $cid);
		}
	}

	/* Walk the list looking for loops; remove any we find */
	$childpath = array();
	check_loop(0);

	/* Sort all the 'children' elements */
	foreach($buildcat as $cid => $dummy)
	{
		$dstr = sprintf("<!-- Sorting for category %d (%s) -->\n",
				$cid, $buildcat[$cid]['name']);
		d_print($dstr);
		if($buildcat[$cid]['has_children']==0)
		{ continue; }

		/* Sort */
		usort($buildcat[$cid]['children'], "children_cmp");
	}

	return($buildcat);
}


/* Comparison function to sort children */
function children_cmp($a, $b)
{
	global $buildcat;
	$child_a = $buildcat[$a];
	$child_b = $buildcat[$b];

	$dstr = sprintf("<!-- Comparing '%s' (a) (%s) with '%s' (b) (%d) -->\n",
			$child_a['name'], $a, $child_b['name'], $b);
	d_print($dstr);

	return strcmp($child_a['name'], $child_b['name']);
}


/* Recursive search of children for loops */
function check_loop($cid)
{
	global $childpath;
	global $debug;
	global $buildcat;

	d_print("<!-- Loop-checking children of '$cid' -->\n");
	$mykids = $buildcat[$cid]['children'];

	if(!$mykids)
	{
		/*
		 * We have no children.  Take ourselves off the list, and back up
		 * to the last level.
		 */
		d_print("<!-- No kids found for '$cid', recursing back -->\n");
		array_pop($childpath);
		return;
	}

	/* Check if any of our kids have been traversed already */
	if( $isect = array_intersect($mykids, $childpath) )
	{
		/*
		 * Whoopsy, we've got LOOPS!  Bad monkey!
		 * Bitch about each one, and take it out.
		 */
		foreach($isect as $dummy => $dup)
		{
			$err = sprintf("<!-- Category '%d' encountered as child "
					. "of category '%d', but is also a parent.  Loops "
					. "are bad, mmkay? -->\n",
					$dup, $cid);
			d_print($err);
			if($admin || $debug)
			{
				print("<p style=\"text-weight: bold;\">\n");
				print("WARNING!  Category '$dup' listead as child of "
						. "'$cid', but is also an ancestor of it!\n");
				print("</p>\n");
			}
		}

		/*
		 * I think there's a better way to do this with
		 * array_splice(), but I'm not quite clear on how it works.
		 * I'm too lazy to figure it out right now, so we'll do this
		 * manually.
		 * Doing it this way is much more efficient if we do it in bulk;
		 * if we find a better way to just chop an item out of the array
		 * (I'm almost certainly you can with array_splice()), do it in
		 * the loop above.
		 */
		$newkids = array();
		while($item = array_shift($mykids))
		{
			if(!(in_array($item, $childpath)))
			{
				array_push($newkids, $item);
			}
		}
		$mykids = $newkids;
		$buildcat[$cid]['children'] = $newkids;
	}

	/*
	 * Done checking our kids; now check each of our kids in turn for
	 * THEIR kids.
	 */
	foreach($mykids as $dummy => $thiskid)
	{
		d_print("<!-- Recursing into child '$thiskid' -->\n");
		array_push($childpath, $thiskid);
		check_loop($thiskid);
	}

	/* Done with our kids' kids. */
	d_print("<!-- Last kid of '$cid' checked, returning -->\n");
	array_pop($childpath);
	return;

	/* Fin */
}

?>
